/*
 * @(#)Native Methods             99/01/16
 *
 * Copyright (c) 1999 Noriki Amano. All Rights Reserved.
 *
 * This program was developed by Noriki Amano at JAIST 
 * as a part of a class library, titled "DAS".
 * All the programs of the language is developed by Noriki 
 * Amano and all rights are reserved by Noriki Amano.
 *
 */

#include<windows.h>
#include<stdio.h>
#include "Environment.h"

/**
 *
 *
 * @author  Noriki Amano
 * @version 1.0, 99/01/16
 * @see
 * @since   JDK1.1.5
 */

/**
 * return value ---> 0 == AC off
 *                   1 == AC
 *                  -1 == error
 */

long Environment_getPowerSource(HEnvironment *unused) {

  SYSTEM_POWER_STATUS powerSource;

  GetSystemPowerStatus(&powerSource);

  return((long)powerSource.ACLineStatus);

}

/**
 * return value ---> battery remainder (%)
 */

long Environment_getBatteryRemainder(HEnvironment *unused) {

  SYSTEM_POWER_STATUS powerSource;

  GetSystemPowerStatus(&powerSource);
   
  return((long)powerSource.BatteryLifePercent);

}

long Environment_getFreeMemory(HEnvironment *unused) {

  MEMORYSTATUS freeMemorySize;

  GlobalMemoryStatus(&freeMemorySize);

  return((long)freeMemorySize.dwAvailPhys);

}

/**
 * return value ---> display width (numerical value)
 */

long Environment_getDisplayWidth(HEnvironment *unused) {

  return((long)GetSystemMetrics(SM_CXSCREEN));

}

/**
 * return value ---> display height (numerical value)
 */

long Environment_getDisplayHeight(HEnvironment *unused) {

  return((long)GetSystemMetrics(SM_CYSCREEN));

}

/**
 * return value ---> disk free space (numerical value)
 *                   -1 == error
 */

long Environment_getDiskFreeSpace(HEnvironment *unused) {

  LPCTSTR drive;
  unsigned long sector, byte, number, total;

  drive = "C:/";
   
  if(GetDiskFreeSpace(drive,&sector,&byte,&number,&total) == FALSE) {
    return((long)-1);
  }

  return((long)sector*byte*number);

}
