/*
 * @(#)Environment.java		99/01/16
 *
 * Copyright (c) 1999 Noriki Amano. All Rights Reserved.
 *
 * This program was developed by Noriki Amano at JAIST 
 * as a part of a class library, titled "DAS".
 * All the programs of the language is developed by Noriki 
 * Amano and all rights are reserved by Noriki Amano.
 *
 */

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;

/**
 *
 *
 * @author  Noriki Amano
 * @version 1.0, 99/01/16
 * @see
 * @since   JDK1.1.5
 */

public class Environment {

  public static String version		= System.getProperty("java.version");
  public static String vendor		= System.getProperty("java.vendor");
  public static String vendorUrl	= System.getProperty("java.vendro.url");
  public static String homeDir		= System.getProperty("java.home");
  public static String apiVersion	= System.getProperty("java.class.version");
  public static String classPath	= System.getProperty("java.class.path");
  public static String osName		= System.getProperty("os.name");
  public static String cpuName		= System.getProperty("os.arch");
  public static String osVersion	= System.getProperty("os.version");
  public static String fileSeparator	= System.getProperty("file.separator");
  public static String pathSeparator	= System.getProperty("path.separator");
  public static String lineSeparator	= System.getProperty("line.separator");
  public static String userName		= System.getProperty("user.name");
  public static String userDir		= System.getProperty("user.home");
  public static String userWorkingDir	= System.getProperty("user.dir");

  public static String localHostName	= null;
  public static String localHostAddr	= null;
  public static String remoteHostName	= null;
  public static String remoteHostAddr	= null;

// Native Methods

  public static native int getPowerSource();
  public static native int getBatteryRemainder();
  public static native int getFreeMemory();
  public static native int getDisplayWidth();
  public static native int getDisplayHeight();
  public static native int getDiskFreeSpace();

  static {
    System.loadLibrary("DAS");
  }

  public Environment() {
    try {
      InetAddress netAddr = InetAddress.getLocalHost();
      localHostName = netAddr.getHostName();
      localHostAddr = netAddr.getHostAddress();
    }
    catch (UnknownHostException e) {
      e.printStackTrace();
    }
  }

  public void setRemoteHost(String remoteHostName) {
    try {
      InetAddress netAddr = InetAddress.getByName(remoteHostName);
      remoteHostName = netAddr.getHostName();
      remoteHostAddr = netAddr.getHostAddress();
    }
    catch (UnknownHostException e) {
      e.printStackTrace();
    }
  }

}
