/*
 * @(#)HelloWorld.java		99/01/16
 *
 * Copyright (c) 1999 Noriki Amano. All Rights Reserved.
 *
 * This program was developed by Noriki Amano at JAIST 
 * as a part of a class library, titled "DAS".
 * All the programs of the language is developed by Noriki 
 * Amano and all rights are reserved by Noriki Amano.
 *
 */

import java.io.*;
import java.util.*;
import java.lang.*;
import java.lang.reflect.*;

/**
 *
 *
 * @author  Noriki Amano
 * @version 1.0, 99/01/16
 * @see
 * @since   JDK1.1.5
 */

public class HelloWorld {

  public HelloWorld() {}

  public String $DOC_HelloWorld_1 = "$COND_HelloWorld_1";
  public EvalArgs $COND_HelloWorld_1(StandardEnv obj) {
    System.out.println($DOC_HelloWorld_1 + " is called!");
    EvalArgs eArgs = new EvalArgs(obj);
    eArgs.element  = new String[] {"display", "battery"};
    eArgs.bools	   = new boolean[] {obj.getDisplay() == "LARGE", 
				    obj.getBattery() == "SMALL"};
    return(eArgs);
  }
  public void $CODE_HelloWorld_1(StandardEnv obj, String str) {
    System.out.println("$CODE_HelloWorld_1" + str);
  }

  public static void main(String args[]) {

    StandardEnv virtualEnv = new StandardEnv();
//    SpecialEnv virtualEnv = new SpecialEnv();

    HelloWorld hw = new HelloWorld();
    Object[] arguments = new Object[2];
    arguments[0] = virtualEnv;
    arguments[1] = " in HelloWorld (adaptable method)";

    StandardCtrl $DISPATCH_StandardCtrl = new StandardCtrl();
    $DISPATCH_StandardCtrl.adaptableCtrl(hw, "HelloWorld", arguments);

    SharedAmethod sa = new SharedAmethod();
    Object[] argObjects = new Object[2];
    argObjects[0] = virtualEnv;
    argObjects[1] = " in SharedAmethod";

    $DISPATCH_StandardCtrl.adaptableCtrl(sa, "SharedAmethod", argObjects);

 System.out.println("--- dispatch strategy is changed ---");

    virtualEnv.setStrategy("negative");
    $DISPATCH_StandardCtrl.adaptableCtrl(sa, "SharedAmethod", argObjects);

 System.out.println("--- dispatch strategy is changed ---");

    virtualEnv.setStrategy("user-like");
    $DISPATCH_StandardCtrl.adaptableCtrl(sa, "SharedAmethod", argObjects);

 System.out.println("--- dispatch strategy is changed ---");

    virtualEnv.setStrategy("positive");
    $DISPATCH_StandardCtrl.adaptableCtrl(sa, "SharedAmethod", argObjects);
  }

}
