/*
 * @(#)Instantiation.java		99/01/16
 *
 * Copyright (c) 1999 Noriki Amano. All Rights Reserved.
 *
 * This program was developed by Noriki Amano at JAIST 
 * as a part of a class library, titled "DAS".
 * All the programs of the language is developed by Noriki 
 * Amano and all rights are reserved by Noriki Amano.
 *
 */

import java.io.*;
import java.util.*;
import java.lang.*;
import java.lang.reflect.*;

/**
 *
 *
 * @author  Noriki Amano
 * @version 1.0, 99/01/16
 * @see
 * @since   JDK1.1.5
 */

public class Instantiation {

  public Instantiation() {}

  public static Object makeInstance(String className, Class[] classArg, Object[] objArg) {
    try {
      Class cls = Class.forName(className);
      Constructor cst = cls.getConstructor(classArg);
      return(cst.newInstance(objArg));
    } catch (ClassNotFoundException e) {
      e.printStackTrace();
    } catch (IllegalAccessException e) {
      e.printStackTrace();
    } catch (InstantiationException e) {
      e.printStackTrace();
    } catch (InvocationTargetException e) {
      e.printStackTrace();
    } catch (NoSuchMethodException e) {
      e.printStackTrace();
    }
    return(null);
  }

  public static Object makeInstance(String className) {
    try {
      return(Class.forName(className).newInstance());
    } catch (ClassNotFoundException e) {
      e.printStackTrace();
    } catch (IllegalAccessException e) {
      e.printStackTrace();
    } catch (InstantiationException e) {
      e.printStackTrace();
    }
    return(null);
  }

}
