/*
 * @(#)MethodList.java		99/01/16
 *
 * Copyright (c) 1999 Noriki Amano. All Rights Reserved.
 *
 * This program was developed by Noriki Amano at JAIST 
 * as a part of a class library, titled "DAS".
 * All the programs of the language is developed by Noriki 
 * Amano and all rights are reserved by Noriki Amano.
 *
 */

import java.awt.*;
import java.awt.event.*;
import java.lang.*;

/**
 *
 *
 * @author  Noriki Amano
 * @version 1.0, 99/01/16
 * @see
 * @since   JDK1.1.5
 */

public class MethodList extends Dialog implements ActionListener {
  protected List methodList	= new List(5, false);

  private Button okayButton	= new Button("Okay");
  private Button cancelButton	= new Button("Cancel");
  private SpecialStrategy targetObj = null;

  public MethodList(SpecialStrategy target) {
    super(new Frame(), "Method Selection", true);

    targetObj = target;
    setTitle("Method Selection");
    setSize(300, 200);
    setLayout(new BorderLayout());
    setBackground(SystemColor.menu);

    Panel buttonPanel = new Panel();
    buttonPanel.setLayout(new FlowLayout());
    buttonPanel.add(okayButton);
    buttonPanel.add(cancelButton);

    okayButton.addActionListener(this);
    cancelButton.addActionListener(this);
//    addWindowListener(this);
//    addMouseListener(this);

    methodList.select(0);
    add("Center", methodList);
    add("South", buttonPanel);
  }

  public void actionPerformed(ActionEvent e) {
    String command = e.getActionCommand();
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      targetObj.UserStrategyResult = "UserStrategyCancel";
      dispose();
    } else if (command.equals("Okay")) {
      targetObj.UserStrategyResult = methodList.getSelectedItem();
      dispose();
    } else if (command.equals("Cancel")) {
      targetObj.UserStrategyResult = "UserStrategyCancel";
      dispose();
    }
//    System.exit(0);
  }
/*
  public void mouseClicked(MouseEvent e) {}
  public void mouseEntered(MouseEvent e) {}
  public void mouseExited(MouseEvent e) {}
  public void mousePressed(MouseEvent e) {}
  public void mouseReleased(MouseEvent e) {}
  
  public void windowOpened(WindowEvent e) {}
  public void windowActivated(WindowEvent e) {}
  public void windowDeactivated(WindowEvent e) {}
  public void windowClosed(WindowEvent e) {}
  public void windowIconified(WindowEvent e){}
  public void windowDeiconified(WindowEvent e){}
  public void windowClosing(WindowEvent e){}
*/
}
