/*
 * @(#)StandardCtrl.java		99/01/16
 *
 * Copyright (c) 1999 Noriki Amano. All Rights Reserved.
 *
 * This program was developed by Noriki Amano at JAIST 
 * as a part of a class library, titled "DAS".
 * All the programs of the language is developed by Noriki 
 * Amano and all rights are reserved by Noriki Amano.
 *
 */

import java.io.*;
import java.util.*;
import java.lang.*;
import java.lang.reflect.*;

/**
 *
 *
 * @author  Noriki Amano
 * @version 1.0, 99/01/16
 * @see
 * @since   JDK1.1.5
 */

public class StandardCtrl implements Serializable {
  protected int ENV = 0;
  protected String DISPATCH = "dispatch";

  protected Object OBJ = null;
  protected BasicCtrl $DISPATCH_BasicCtrl = new BasicCtrl();

  public StandardCtrl() {
    this("StandardStrategy");
  }

  public StandardCtrl(String strategyName) {
    Class[] classArg = {AdaptableMethod[].class};
    Object[] objArg  = {$DISPATCH_BasicCtrl.amTbl};
    OBJ = Instantiation.makeInstance(strategyName, classArg, objArg);
  }

  public Object adaptableCtrl(Object obj, String methodName, Object[] argObjects) {
    StandardEnv virtualEnv = (StandardEnv)argObjects[ENV];
    Object[] subArg   = {virtualEnv};
    Object[] argArray = {virtualEnv, DISPATCH, subArg};
    $DISPATCH_BasicCtrl.adaptableCtrl(OBJ, DISPATCH, argArray);
    return($DISPATCH_BasicCtrl.adaptableCtrl(obj, methodName, argObjects));
  }

}
