/*
 * @(#)StandardEventCtrl.java		99/01/16
 *
 * Copyright (c) 1999 Noriki Amano. All Rights Reserved.
 *
 * This program was developed by Noriki Amano at JAIST 
 * as a part of a class library, titled "DAS".
 * All the programs of the language is developed by Noriki 
 * Amano and all rights are reserved by Noriki Amano.
 *
 */

import java.io.*;
import java.util.*;
import java.lang.*;

/**
 *
 *
 * @author  Noriki Amano
 * @version 1.0, 99/01/16
 * @see
 * @since   JDK1.1.5
 */

public class StandardEventCtrl extends Thread implements Serializable {

  public StandardEnv virEnv = new StandardEnv();

  public String $DOC_changeStrategy_1 = "This method changes the strategy for rich machine.";
  public EvalArgs $COND_changeStrategy_1(StandardEnv obj) {
    System.out.println($DOC_changeStrategy_1 + " condition is evaluated!");
    EvalArgs eArgs = new EvalArgs(obj);
    eArgs.element  = new String[] {"cpu"};
    eArgs.bools	   = new boolean[] {"Pentium2".equals(obj.cpuName)};
    return(eArgs);
  }
  public void $CODE_changeStrategy_1(StandardEnv obj) {
    System.out.println($DOC_changeStrategy_1 + " codes are executed!");
    virEnv.setStrategy("default");
  }

  public String $DOC_changeStrategy_2 = "This method changes the strategy for poor machine.";
  public EvalArgs $COND_changeStrategy_2(StandardEnv obj) {
    System.out.println($DOC_changeStrategy_2 + " condition is evaluated!");
    EvalArgs eArgs = new EvalArgs(obj);
    eArgs.element  = new String[] {"cpu"};
    eArgs.bools	   = new boolean[] {"Pentium".equals(obj.cpuName)};
    return(eArgs);
  }
  public void $CODE_changeStrategy_2(StandardEnv obj) {
    System.out.println($DOC_changeStrategy_2 + " codes are executed!");
    virEnv.setStrategy("and");
  }

  public String $DOC_stateFuncCall_1 = "This method changes the function call for rich machine.";
  public EvalArgs $COND_stateFuncCall_1(StandardEnv obj) {
    System.out.println($DOC_stateFuncCall_1 + " condition is evaluated!");
    EvalArgs eArgs = new EvalArgs(obj);
    eArgs.element  = new String[] {"power"};
    eArgs.bools	   = new boolean[] {obj.getPower() == "AC-POWER"};
    return(eArgs);
  }
  public void $CODE_stateFuncCall_1(StandardEnv obj) {
    System.out.println($DOC_stateFuncCall_1 + " codes are executed!");
/*
      userDefinedEvent0(envObj);
      userDefinedEvent1(envObj);
      userDefinedEvent2(envObj);
      userDefinedEvent3(envObj);
      userDefinedEvent4(envObj);
      userDefinedEvent5(envObj);
      userDefinedEvent6(envObj);
      userDefinedEvent7(envObj);
      userDefinedEvent8(envObj);
      userDefinedEvent9(envObj);
*/
  }

  public String $DOC_stateFuncCall_2 = "This method changes the strategy for poor machine.";
  public EvalArgs $COND_stateFuncCall_2(StandardEnv obj) {
    System.out.println($DOC_stateFuncCall_2 + " condition is evaluated!");
    EvalArgs eArgs = new EvalArgs(obj);
    eArgs.element  = new String[] {"power", "battery"};
    eArgs.bools	   = new boolean[] {"BATTERY".equals(obj.getPower()),
				    "MIDDLE".equals(obj.getBattery())};
    return(eArgs);
  }
  public void $CODE_stateFuncCall_2(StandardEnv obj) {
    System.out.println($DOC_stateFuncCall_2 + " codes are executed!");
/*
      userDefinedEvent0(envObj);
      userDefinedEvent1(envObj);
      userDefinedEvent2(envObj);
      userDefinedEvent3(envObj);
      userDefinedEvent4(envObj);
      userDefinedEvent5(envObj);
*/
  }

  protected Object envObj	= null;
  protected Object targetObj	= null;
  protected StateEvent eventObj	= new StateEvent();

  protected StandardEventCtrl THIS = null;

  private long initialTime	= System.currentTimeMillis(); // mm/Sec
  private long timeOut		= 0;
  private String displaySize	= null;
  private String memorySize	= null;
  private String powerSource	= null;
  private String diskFreeSize	= null;
  private String batteryRemainder = null;

  private String userState0	= null;
  private String userState1	= null;
  private String userState2	= null;
  private String userState3	= null;
  private String userState4	= null;
  private String userState5	= null;
  private String userState6	= null;
  private String userState7	= null;
  private String userState8	= null;
  private String userState9	= null;

  public StandardEventCtrl() {
    this(20000);
  }

  public StandardEventCtrl(long maxTime) {
    THIS = this;
    timeOut = maxTime;
  }

  public String getDisk(Object obj) { return(((StandardEnv)obj).getDisk()); }
  public String getPower(Object obj) { return(((StandardEnv)obj).getPower()); }
  public String getMemory(Object obj) { return(((StandardEnv)obj).getMemory()); }
  public String getDisplay(Object obj) { return(((StandardEnv)obj).getDisplay()); }
  public String getBattery(Object obj) { return(((StandardEnv)obj).getBattery()); }

  public String getUserState0(Object obj) { return(null); }
  public String getUserState1(Object obj) { return(null); }
  public String getUserState2(Object obj) { return(null); }
  public String getUserState3(Object obj) { return(null); }
  public String getUserState4(Object obj) { return(null); }
  public String getUserState5(Object obj) { return(null); }
  public String getUserState6(Object obj) { return(null); }
  public String getUserState7(Object obj) { return(null); }
  public String getUserState8(Object obj) { return(null); }
  public String getUserState9(Object obj) { return(null); }

  public void enable(Object target, Object env) {
    targetObj	= target;
    envObj	= env;

    diskFreeSize = getDisk(env);
    powerSource	 = getPower(env);
    memorySize	 = getMemory(env);
    displaySize	 = getDisplay(env);
    batteryRemainder = getBattery(env);

    userState0 = getUserState0(env);
    userState1 = getUserState1(env);
    userState2 = getUserState2(env);
    userState3 = getUserState3(env);
    userState4 = getUserState4(env);
    userState5 = getUserState5(env);
    userState6 = getUserState6(env);
    userState7 = getUserState7(env);
    userState8 = getUserState8(env);
    userState9 = getUserState9(env);

    THIS.start();
  }

  public void disable() {
    THIS.stop();
  }

  public void run() {
    initialTime	= System.currentTimeMillis();
    for (;;) {

      timerEvent(envObj);
      powerEvent(envObj);
/*
      diskEvent(envObj);
      memoryEvent(envObj);
      batteryEvent(envObj);
      displayEvent(envObj);

      StandardCtrl $DISPATCH_StandardCtrl = new StandardCtrl();
      Object[] argObj = new Object[1];
      argObj[0] = virEnv;
      $DISPATCH_StandardCtrl.adaptableCtrl(THIS, "changeStrategy", argObj);
      $DISPATCH_StandardCtrl.adaptableCtrl(THIS, "stateFuncCall", argObj);
*/
    }
  }

// call-back-method = timerInterrupt(StateEvent event, StandardEnv env)
  public void timerEvent(Object env) {
    long currentTime = System.currentTimeMillis();
    if (timeOut <= (currentTime - initialTime)) {
      System.out.println("timer event was occured!");
      eventObj.setOccurTime(System.currentTimeMillis());
      eventObj.setEventKind("Timer");
      eventObj.setEventState("");
      StandardCallBack scb = (StandardCallBack)targetObj;
      scb.timerInterrupt(eventObj, (StandardEnv)env);
      initialTime = currentTime;
    }
  } 

// call-back-method = diskFreeSizeChanged(StateEvent event, StandardEnv env)
  public void diskEvent(Object env) { 
    String diskSize = getDisk(env);
//    if (!diskFreeSize.equals(diskSize)) {
      System.out.println("disk event was occured!");
      eventObj.setOccurTime(System.currentTimeMillis());
      eventObj.setEventKind("Disk");
      eventObj.setEventState(diskSize);
      StandardCallBack scb = (StandardCallBack)targetObj;
      scb.diskFreeSizeChanged(eventObj, (StandardEnv)env);
//    }
  }

// call-back-method = powerSourceChanged(StateEvent event, StandardEnv env)
  public void powerEvent(Object env) {
    String power = getPower(env);
    if (!powerSource.equals(power)) {
      System.out.println("power event was occured!");
      eventObj.setOccurTime(System.currentTimeMillis());
      eventObj.setEventKind("Power");
      eventObj.setEventState(power);
      StandardCallBack scb = (StandardCallBack)targetObj;
      scb.powerSourceChanged(eventObj, (StandardEnv)env);
    }
  } 

// call-back-method = memoryFreeSizeChanged(StateEvent event, StandardEnv env)
  public void memoryEvent(Object env) {
    String memory = getMemory(env);
    if (!memorySize.equals(memory)) {
      System.out.println("memory event was occured!");
      eventObj.setOccurTime(System.currentTimeMillis());
      eventObj.setEventKind("Memory");
      eventObj.setEventState(memory);
      StandardCallBack scb = (StandardCallBack)targetObj;
      scb.memoryFreeSizeChanged(eventObj, (StandardEnv)env);
    }
  } 

// call-back-method = displaySizeChanged(StateEvent event, StandardEnv env)
  public void displayEvent(Object env) { 
    String display = getDisplay(env);
    if (!displaySize.equals(display)) {
      System.out.println("display event was occured!");
      eventObj.setOccurTime(System.currentTimeMillis());
      eventObj.setEventKind("Display");
      eventObj.setEventState(display);
      StandardCallBack scb = (StandardCallBack)targetObj;
      scb.displaySizeChanged(eventObj, (StandardEnv)env);
    }
  }

// call-back-method = batteryRemainderChanged(StateEvent event, StandardEnv env)
  public void batteryEvent(Object env) {
    String battery = getBattery(env);
    if (!batteryRemainder.equals(battery)) {
      System.out.println("battery event was occured!");
      eventObj.setOccurTime(System.currentTimeMillis());
      eventObj.setEventKind("Battery");
      eventObj.setEventState(battery);
      StandardCallBack scb = (StandardCallBack)targetObj;
      scb.batteryRemainderChanged(eventObj, (StandardEnv)env);
    }
  } 

  public void userDefinedEvent0(Object env) {}
  public void userDefinedEvent1(Object env) {}
  public void userDefinedEvent2(Object env) {}
  public void userDefinedEvent3(Object env) {}
  public void userDefinedEvent4(Object env) {}
  public void userDefinedEvent5(Object env) {}
  public void userDefinedEvent6(Object env) {}
  public void userDefinedEvent7(Object env) {}
  public void userDefinedEvent8(Object env) {}
  public void userDefinedEvent9(Object env) {}

}
