/*
 * @(#)TypeCheck.java		99/01/16
 *
 * Copyright (c) 1999 Noriki Amano. All Rights Reserved.
 *
 * This program was developed by Noriki Amano at JAIST 
 * as a part of a class library, titled "DAS".
 * All the programs of the language is developed by Noriki 
 * Amano and all rights are reserved by Noriki Amano.
 *
 */

import java.io.*;
import java.util.*;
import java.lang.*;
import java.lang.reflect.*;

/**
 *
 *
 * @author  Noriki Amano
 * @version 1.0, 99/01/16
 * @see
 * @since   JDK1.1.5
 */

public class TypeCheck {
  public static String DISPATCH = "dispatch";

  public TypeCheck() {}

  public static boolean condMethodCheck(StandardEnv obj, Method condMethod, String type) {
    String argClass = obj.getClass().getName();
    Class[] parm = condMethod.getParameterTypes();
    String parmClass	= parm[0].getName();
    String returnClass	= condMethod.getReturnType().getName();
    return(argClass.equals(parmClass) && returnClass.equals(type));
  }

  public static boolean codeMethodCheck(Method mth, String methodName, Object[] args) {
    if (methodName.equals(DISPATCH)) {
      return(true);
    }
    Class[] parm = mth.getParameterTypes();
    if (parm.length != args.length) {
      return(false);
    }
    for (int i = 0; i < parm.length; i++) {
      String parmClass	= parm[i].getName();
      String argClass	= args[i].getClass().getName();
      if (!parmClass.equals(argClass)) {
	return(false);
      }
    }
    return(true);
  }

}
